%======================================================================
%                    B I N R E M A P . M 
%                    doc: Fri Mar 20 13:12:52 2009
%                    dlm: Fri Mar 20 15:15:56 2009
%                    (c) 2009 A.M. Thurnherr
%                    uE-Info: 16 54 NIL 0 0 72 2 2 8 NIL ofnI
%======================================================================

% - not used for LADCP processing
% - bin-remapping code extracted from [loadrdi.m]
% - 2 versions of code:
%	- "Visbeck" code: used up to version IX_5
%	- "RDI" code: commented-out in older versions
% - routine returns remap indices for uplooking instrument, bin 3
% - this can be interpreted with Fig.3 in RDI coord-trans manual
% - e.g. [V,R]=binremap(20,0) => index of beam 4 must be > 3

function [V,R]=binremap(pitch,roll)

d2r=pi/180;
C30=cos(20*d2r);
S30=sin(20*d2r);

ZSG = [+1, -1, +1, -1];	% for upward looking
%%%ZSG = [+1, -1, -1, +1];		% for downward looking

RR=roll.*d2r;
KA=sqrt(1.0 - (sin(pitch.*d2r).*sin(roll.*d2r)).^2);
PP=asin(sin(pitch.*d2r).*cos(roll.*d2r)./KA);

CP=cos(PP); CR=cos(RR); 
SP=sin(PP); SR=sin(RR); 

M(1) = -SR.*CP;
M(2) = SP;
M(3) = CP.*CR;

% Visbeck Code
SCV(1) = (M(3).*C30 + ZSG(1).*M(1).*S30);
SCV(2) = (M(3).*C30 + ZSG(2).*M(1).*S30);
SCV(3) = (M(3).*C30 + ZSG(3).*M(2).*S30);
SCV(4) = (M(3).*C30 + ZSG(4).*M(2).*S30);

% RDI/Orton Code
SCR(1) = C30./(M(3).*C30 + ZSG(1).*M(1).*S30);
SCR(2) = C30./(M(3).*C30 + ZSG(2).*M(1).*S30);
SCR(3) = C30./(M(3).*C30 + ZSG(3).*M(2).*S30);
SCR(4) = C30./(M(3).*C30 + ZSG(4).*M(2).*S30);

for i=1:4, 
  V(i)=fix(3.*SCV(i)+0.5); 
  R(i)=fix(3.*SCR(i)+0.5); 
end

